// DraughtsView.cpp : implementation of the CDraughtsView class
//

#include "stdafx.h"
#include "Draughts.h"

#include "DraughtsDoc.h"
#include "DraughtsView.h"

#include "PlayerDlg.h"
#include "ViewDlg.h"
#include "DataDlg.h"

extern int language;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDraughtsView

IMPLEMENT_DYNCREATE(CDraughtsView, CView)

BEGIN_MESSAGE_MAP(CDraughtsView, CView)
	//{{AFX_MSG_MAP(CDraughtsView)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_GAME_NEW, OnGameNew)
	ON_COMMAND(ID_MOVE_MOVE, OnMoveMove)
	ON_UPDATE_COMMAND_UI(ID_MOVE_MOVE, OnUpdateMoveMove)
	ON_COMMAND(ID_MOVE_SUGGEST, OnMoveSuggest)
	ON_UPDATE_COMMAND_UI(ID_MOVE_SUGGEST, OnUpdateMoveSuggest)
	ON_COMMAND(ID_SETTINGS_PLAYERS, OnSettingsPlayers)
	ON_COMMAND(ID_MOVE_UNDO, OnMoveUndo)
	ON_UPDATE_COMMAND_UI(ID_MOVE_UNDO, OnUpdateMoveUndo)
	ON_WM_SIZE()
	ON_COMMAND(ID_MOVE_REDO, OnMoveRedo)
	ON_UPDATE_COMMAND_UI(ID_MOVE_REDO, OnUpdateMoveRedo)
	ON_COMMAND(ID_MOVE_GIVEUP, OnMoveGiveUp)
	ON_UPDATE_COMMAND_UI(ID_MOVE_GIVEUP, OnUpdateMoveGiveUp)
	ON_WM_TIMER()
	ON_COMMAND(ID_SETTINGS_GAME_MJ, OnSettingsGameMJ)
	ON_UPDATE_COMMAND_UI(ID_SETTINGS_GAME_MJ, OnUpdateSettingsGameMJ)
	ON_COMMAND(ID_SETTINGS_VIEW, OnSettingsView)
	ON_COMMAND(ID_GAME_SAVE, OnGameSave)
	ON_UPDATE_COMMAND_UI(ID_GAME_SAVE, OnUpdateGameSave)
	ON_COMMAND(ID_GAME_OPEN, OnGameOpen)
	ON_COMMAND(ID_GAME_SAVE_AS, OnGameSaveAs)
	ON_UPDATE_COMMAND_UI(ID_GAME_SAVE_AS, OnUpdateGameSaveAs)
	ON_COMMAND(ID_OBJECTS_CORE, OnObjectsCore)
	ON_COMMAND(ID_OBJECTS_MANAGER, OnObjectsManager)
	ON_COMMAND(ID_OBJECTS_REFEREE, OnObjectsReferee)
	ON_COMMAND(ID_OBJECTS_WHITE, OnObjectsWhite)
	ON_COMMAND(ID_OBJECTS_BLACK, OnObjectsBlack)
	ON_COMMAND(ID_OBJECTS_STATE, OnObjectsState)
	ON_COMMAND(ID_OBJECTS_BOARD, OnObjectsBoard)
	ON_COMMAND(ID_OBJECTS_HISTORY, OnObjectsHistory)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_HELP_HELP, OnHelpHelp)
	ON_COMMAND(ID_HELP_RULES, OnHelpRules)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_GAME_NEW_0, OnGameNew)
	ON_COMMAND(ID_MOVE_GIVEUP_0, OnMoveGiveUp)
	ON_UPDATE_COMMAND_UI(ID_MOVE_GIVEUP_0, OnUpdateMoveGiveUp)
	ON_COMMAND(ID_MOVE_MOVE_0, OnMoveMove)
	ON_UPDATE_COMMAND_UI(ID_MOVE_MOVE_0, OnUpdateMoveMove)
	ON_COMMAND(ID_MOVE_REDO_0, OnMoveRedo)
	ON_UPDATE_COMMAND_UI(ID_MOVE_REDO_0, OnUpdateMoveRedo)
	ON_COMMAND(ID_MOVE_SUGGEST_0, OnMoveSuggest)
	ON_UPDATE_COMMAND_UI(ID_MOVE_SUGGEST_0, OnUpdateMoveSuggest)
	ON_COMMAND(ID_MOVE_UNDO_0, OnMoveUndo)
	ON_UPDATE_COMMAND_UI(ID_MOVE_UNDO_0, OnUpdateMoveUndo)
	ON_COMMAND(ID_SETTINGS_GAME_MJ_0, OnSettingsGameMJ)
	ON_UPDATE_COMMAND_UI(ID_SETTINGS_GAME_MJ_0, OnUpdateSettingsGameMJ)
	ON_COMMAND(ID_SETTINGS_PLAYERS_0, OnSettingsPlayers)
	ON_COMMAND(ID_SETTINGS_VIEW_0, OnSettingsView)
	ON_COMMAND(ID_GAME_SAVE_0, OnGameSave)
	ON_UPDATE_COMMAND_UI(ID_GAME_SAVE_0, OnUpdateGameSave)
	ON_COMMAND(ID_GAME_OPEN_0, OnGameOpen)
	ON_COMMAND(ID_GAME_SAVE_AS_0, OnGameSaveAs)
	ON_UPDATE_COMMAND_UI(ID_GAME_SAVE_AS_0, OnUpdateGameSaveAs)
	ON_COMMAND(ID_OBJECTS_BLACK_0, OnObjectsBlack)
	ON_COMMAND(ID_OBJECTS_BOARD_0, OnObjectsBoard)
	ON_COMMAND(ID_OBJECTS_CORE_0, OnObjectsCore)
	ON_COMMAND(ID_OBJECTS_HISTORY_0, OnObjectsHistory)
	ON_COMMAND(ID_OBJECTS_MANAGER_0, OnObjectsManager)
	ON_COMMAND(ID_OBJECTS_REFEREE_0, OnObjectsReferee)
	ON_COMMAND(ID_OBJECTS_STATE_0, OnObjectsState)
	ON_COMMAND(ID_OBJECTS_WHITE_0, OnObjectsWhite)
	ON_COMMAND(ID_HELP_HELP_0, OnHelpHelp)
	ON_COMMAND(ID_HELP_RULES_0, OnHelpRules)
	ON_COMMAND(ID_OCX_ABOUT, OnOcxAbout)
	ON_COMMAND(ID_OCX_ABOUT_0, OnOcxAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDraughtsView construction/destruction

CDraughtsView::CDraughtsView()
{
	// TODO: add construction code here
	
	move_doing.started = false;
	move_doing.move.Empty();

	bkg_color = RGB (89,170,138);
//	board.dc = new CDC;
//	board.bmp = new CBitmap;
	dcs.figure = new CDC;
	dcs.mask = new CDC;
	dcs.temp = new CDC;
	bmps.wm = new CBitmap;
	bmps.wk = new CBitmap;
	bmps.bm = new CBitmap;
	bmps.bk = new CBitmap;
	bmps.mask = new CBitmap;

	WHITE = 0; BLACK = 1;
	game_running = game_ended_mesbox = false;
	players.comp[WHITE] = false;
	players.comp[BLACK] = true;
	players.iqs[0] = 2;
	players.iqs[1] = 2;
	players.times[0] = 2;
	players.times[1] = 2;
	undo_times = 0;
	draw_fields_numbers = false;
	move_notation = 0;
	must_jump = true;
	time.game = time.white = time.black = 0;
	FCV = FCH = 8;

	s_true = "TRUE";
	s_false = "FALSE";
	s_white = "WHITE";
	s_black = "BLACK";
	s_wdraw = "WDRAW";
	s_bdraw = "BDRAW";
	s_wmiss = "WMISS";
	s_bmiss = "BMISS";

	file_name = "";
	player_on_turn = 2;
}

CDraughtsView::~CDraughtsView()
{
//	board.bmp->DeleteObject ();
	bmps.wm->DeleteObject ();
	bmps.wk->DeleteObject ();
	bmps.bm->DeleteObject ();
	bmps.bk->DeleteObject ();
	bmps.mask->DeleteObject ();
//	delete board.dc;
//	delete board.bmp;
	delete dcs.figure;
	delete dcs.mask;
	delete dcs.temp;
	delete bmps.wm;
	delete bmps.wk;
	delete bmps.bm;
	delete bmps.bk;
	delete bmps.mask;
}

/////////////////////////////////////////////////////////////////////////////
// CDraughtsView drawing

void CDraughtsView::OnDraw(CDC* pDC)
{
	CDraughtsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	
	CRect rect (0, 0, ::GetSystemMetrics(SM_CXSCREEN), ::GetSystemMetrics(SM_CYSCREEN));
	pDC->FillSolidRect (rect, bkg_color);
	
	DrawBoard (pDC);
	DrawTime(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CDraughtsView diagnostics

#ifdef _DEBUG
void CDraughtsView::AssertValid() const
{
	CView::AssertValid();
}

void CDraughtsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDraughtsDoc* CDraughtsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDraughtsDoc)));
	return (CDraughtsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDraughtsView message handlers


void CDraughtsView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (game_running) {
		if (!players.comp[player_on_turn]) {
			if ((point.x >= board.startx) && (point.x < board.startx + board.size) &&
				(point.y >= board.starty) && (point.y < board.starty + board.size)) {
				int x = ((point.x - board.startx) * FCH) / board.size;
				int y = 7 - ((point.y - board.starty) * FCV) / board.size;
				move_doing.started = true;
				CString mv_list = OCX.GetAllMoves();
				if (move_doing.move.IsEmpty()) {
					if (player_on_turn == WHITE) move_doing.move = s_white;
					else if (player_on_turn == BLACK) move_doing.move = s_black;
					ShowPositions(x, y, &mv_list);
				}
				move_doing.move += ' ';
				move_doing.move += y / 10 + '0';
				move_doing.move += y % 10 + '1';
				move_doing.move += x / 10 + '0';
				move_doing.move += x % 10 + '1';
				
				int index = mv_list.Find(move_doing.move);
				if (index != -1) {
					int index0 = index + move_doing.move.GetLength() + 1;
					if (((index0 < mv_list.GetLength()) && (mv_list[index0] == move_doing.move[0])) || (index0 >= mv_list.GetLength())) {
						CString mv_list0 = mv_list.Right(mv_list.GetLength() - index0);
						if (mv_list0.Find(move_doing.move) == -1) DoMove();
					}
				}
			}
			else if (!move_doing.move.IsEmpty()) DoMove ();
		}
		else if (undo_times) {
			move_doing.move.Empty();
			CString str; str.Format("%02i", players.times[player_on_turn]);
			move_doing.move = OCX.GetMove(str);
			if (move_doing.move != s_false) DoMove();
			else MessageBox (CString((LPCSTR)(IDS_ERR_GET_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
		}
	}

	CView::OnLButtonDown(nFlags, point);
}

void CDraughtsView::DrawBoard(CDC* pDC)
{
	CRect rect;
	GetClientRect(rect);
//	BITMAP bitmap;
//	board.bmp->GetBitmap(&bitmap);
	board.size = (4 * rect.Height ()) / 5;
	board.starty = board.startx = board.size / FCH;

	//pDC->StretchBlt (board.startx, board.starty, FCH * (board.size / FCH), FCV * (board.size / FCV), board.dc, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCCOPY);
	int i, j;
	long col;
	rect.top = board.starty; rect.bottom = rect.top + board.starty;
	for (i = 0; i < FCV; i++) {
		rect.left = board.startx; rect.right = rect.left + board.startx;
		for (j = 0; j < FCH; j++) {
			if (((i % 2) && (j % 2)) || ((!(i % 2)) && (!(j % 2)))) col = RGB(255,255,255); else col = RGB(128,64,64);
			pDC->FillSolidRect (rect, col);
			rect.left += board.startx; rect.right += board.startx;
		}
		rect.top += board.starty; rect.bottom += board.starty;
	}
	
	pDC->SetBkColor(bkg_color);
	int font_w = 6, font_h = 12;
	for (int k = 0; k < FCV; k++) {
		pDC->TextOut (board.startx - (board.size / FCH) / 2 - font_w / 2, board.starty + k * board.size / FCV + (board.size / FCV) / 2 - font_h / 2, CString ((FCV - 1) - k + '1'));
		pDC->TextOut (board.startx + board.size + (board.size / FCH) / 2 - font_w / 2, board.starty + k * board.size / FCV + (board.size / FCV) / 2 - font_h / 2, CString ((FCV - 1) - k + '1'));
		pDC->TextOut (board.startx + k * board.size / FCH + (board.size / FCH) / 2 - font_w / 2, board.starty - (board.size / FCV) / 2 - font_h / 2, CString (k + 'a'));
		pDC->TextOut (board.startx + k * board.size / FCH + (board.size / FCH) / 2 - font_w / 2, board.starty + board.size + (board.size / FCV) / 2 - font_h / 2, CString (k + 'a'));
	}
	
	CString situation = OCX.GetSituation();
	char color, type;
	int first = 6;
	for (i = 0; i < FCV; i++)
		for (j = 0; j < FCH; j++) {
			color = situation[first + (i * FCV + j) * 3];
			type = situation[first + (i * FCV + j) * 3 + 1];
			if (type != '0') {
				if (color == '0') 
					if (type == '2') dcs.figure->SelectObject (bmps.wk);
					else dcs.figure->SelectObject (bmps.wm);
				else
					if (type == '2') dcs.figure->SelectObject (bmps.bk);
					else dcs.figure->SelectObject (bmps.bm);
				DrawFigure (pDC, (FCV - 1) - i, j);
			}
		}
	
	if (draw_fields_numbers) DrawFieldsNumbers(pDC);
}

void CDraughtsView::DrawFigure(CDC* pDC, int i, int j)
{
	BITMAP bitmap;
	bmps.mask->GetBitmap (&bitmap);
	
	//dcs.temp->BitBlt (0, 0, bitmap.bmWidth, bitmap.bmHeight, board.dc, j * bitmap.bmWidth, i * bitmap.bmHeight, NOTSRCCOPY);
	dcs.temp->StretchBlt (0, 0, bitmap.bmWidth, bitmap.bmHeight, pDC,board.startx + j * (board.size / FCH), board.starty + i * (board.size / FCV), board.size / FCH, board.size / FCV, NOTSRCCOPY);
	dcs.temp->BitBlt (0, 0, bitmap.bmWidth, bitmap.bmHeight, dcs.mask, 0, 0, SRCAND);
	dcs.temp->BitBlt (0, 0, bitmap.bmWidth, bitmap.bmHeight, dcs.figure, 0, 0, SRCINVERT);
	pDC->StretchBlt (board.startx + j * (board.size / FCH), board.starty + i * (board.size / FCV), board.size / FCH, board.size / FCV, dcs.temp, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCCOPY);
}

void CDraughtsView::OnGameNew() 
{
	// TODO: Add your command handler code here
	
	if (game_running) 
		if (MessageBox (CString((LPCSTR)(IDS_ABORT_GAME + language)), CString((LPCSTR)(IDS_CONFIRMATION + language)), MB_ICONQUESTION | MB_YESNO) == IDNO) return;
	if (OCX.InitGame() == s_true) {
		game_running = true;
		game_ended_mesbox = false;
		move_doing.started = false;
		move_doing.move.Empty();
		undo_times = 0;
		old_tick_count = ::GetTickCount(); ms_count = 0;
		time.game = time.white = time.black = 0; DrawTime(GetDC());
		SetTimer(ID_TIMER, 100, NULL);
		movehistory.ResetContent();
		UpdateState();
		file_name = "game.dsf";
		AfxGetMainWnd()->SetWindowText((CString)AfxGetAppName() + " - " + file_name);
	}
	else MessageBox (CString((LPCSTR)(IDS_ERR_NEW_GAME + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
}

void CDraughtsView::OnMoveMove() 
{
	// TODO: Add your command handler code here
	if (game_running) {
		if (!players.comp[player_on_turn]) {
			if (!move_doing.move.IsEmpty()) DoMove ();
		}
		else if (undo_times) {
			move_doing.move.Empty();
			CString str; str.Format("%02i", players.times[player_on_turn]);
			move_doing.move = OCX.GetMove(str);
			if (move_doing.move != s_false) DoMove();
			else MessageBox (CString((LPCSTR)(IDS_ERR_GET_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
		}
	}

}

void CDraughtsView::OnUpdateMoveMove(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ((game_running) && ((players.comp[player_on_turn]) || (!move_doing.move.IsEmpty())))
		pCmdUI->Enable (true);
	else pCmdUI->Enable (false);
}

void CDraughtsView::OnMoveSuggest() 
{
	// TODO: Add your command handler code here
	if (game_running) {
		if (!players.comp[player_on_turn]) {
			CString str; str.Format("%02i", players.times[player_on_turn]);
			CString move = "";
			move = OCX.GetMove(str);
			if (move != s_false) MessageBox (MoveStrToHistStr(&move), CString((LPCSTR)(IDS_SUGGESTED_MOVE + language)));
			else MessageBox (CString((LPCSTR)(IDS_ERR_GET_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
		}
	}
}

void CDraughtsView::OnUpdateMoveSuggest(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ((game_running) && (!players.comp[player_on_turn])) pCmdUI->Enable (true);
	else pCmdUI->Enable (false);	
}

void CDraughtsView::OnSettingsPlayers() 
{
	// TODO: Add your command handler code here
	CPlayerDlg dialog;
	
	if (!players.comp[WHITE]) dialog.m_type_w = 0;
	else dialog.m_type_w = 1;
	if (!players.comp[BLACK]) dialog.m_type_b = 0;
	else dialog.m_type_b = 1;
	dialog.m_iq_w = players.iqs[WHITE];
	dialog.m_iq_b = players.iqs[BLACK];
	int tbl[10] = {0,1,2,3,4,5,10,15,20,30};
	int i = 0; while ((i < 10) && (tbl[i] != players.times[WHITE])) i++;
	dialog.m_time_w = i;
	i = 0; while ((i < 10) && (tbl[i] != players.times[BLACK])) i++;
	dialog.m_time_b = i;
			
	dialog.DoModal ();
	
	if (!dialog.m_type_w) players.comp[WHITE] = false;
	else players.comp[WHITE] = true;
	if (!dialog.m_type_b) players.comp[BLACK] = false;
	else players.comp[BLACK] = true;
	players.iqs[WHITE] = dialog.m_iq_w;
	players.iqs[BLACK] = dialog.m_iq_b;
	players.times[WHITE] = tbl[dialog.m_time_w];
	players.times[BLACK] = tbl[dialog.m_time_b];

	CString str; str.Format(" %i", players.iqs[WHITE] + 1);
	if (OCX.InitPlayer(s_white + str) == s_false)
		MessageBox (CString((LPCSTR)(IDS_ERR_INIT_PLAYER + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
	str.Format(" %i", players.iqs[BLACK] + 1);
	if (OCX.InitPlayer(s_black + str) == s_false)
		MessageBox (CString((LPCSTR)(IDS_ERR_INIT_PLAYER + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
}

void CDraughtsView::OnMoveUndo() 
{
	// TODO: Add your command handler code here
	if (game_running) {
		if (OCX.UndoMove() == s_true) {
			undo_times++; UpdateState();
		}
		else MessageBox (CString((LPCSTR)(IDS_ERR_UNDO_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
	}	
}

void CDraughtsView::OnUpdateMoveUndo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ((game_running) && (movehistory.GetCount()))
		pCmdUI->Enable (true);
	else pCmdUI->Enable (false);		
}

void CDraughtsView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if (movehistory) {	
		CRect rect;
		GetClientRect (rect);
		int h = (4 * rect.Height ()) / 5, w = (4 * (rect.Width () - rect.Height ())) / 5;
		rect.left = (rect.Height () + rect.Width() - w) / 2; rect.top = h / FCV + 15; rect.right = rect.left + w; rect.bottom = rect.top + h;
		movehistory.MoveWindow (rect);
	}
}

void CDraughtsView::SetStatusBar()
{
	CString text, text0;
	bool end = false;

	CString str = OCX.GetSituation(); str = str.Left(5);
	CString p = OCX.OnMove();
	if (p == s_white) player_on_turn = WHITE;
	else if (p == s_black) player_on_turn = BLACK;
	if ((str[1] == s_wdraw[1]) || (str[1] == s_wmiss[1])) {
		game_running = false; end = true;
		text.LoadString (IDS_GAME_ENDED + language); text += ". ";
		if (str[1] == s_wmiss[1]) {
			text0.LoadString (IDS_WINNER + language); text0 += ": ";
			text += text0;
			char l = str[0];
			if (l == s_black[0]) text0.LoadString (IDS_WHITE + language);
			else if (l == s_white[0]) text0.LoadString (IDS_BLACK + language);
		}
		else text0.LoadString (IDS_DRAW + language);
	}
	else {	
		text.LoadString (IDS_PLAYER_ON_TURN + language); text += ": ";
		if (player_on_turn == WHITE) text0.LoadString (IDS_WHITE + language);
		else if (player_on_turn == BLACK) text0.LoadString (IDS_BLACK + language);
	}
	text += text0;

	((CFrameWnd*)GetParent ())->SetMessageText (text);
	if ((!game_ended_mesbox) && (end)) { game_ended_mesbox = true; MessageBox(text, ""); }
}

void CDraughtsView::OnMoveRedo()
{
	// TODO: Add your command handler code here
	if (game_running) {
		if (OCX.RedoMove() == s_true) { 
			undo_times--; UpdateState();
		}
		else MessageBox (CString((LPCSTR)(IDS_ERR_REDO_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
	}	
}

void CDraughtsView::OnUpdateMoveRedo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ((game_running) && (undo_times)) pCmdUI->Enable (true);
	else pCmdUI->Enable (false);			
}

void CDraughtsView::DoMove()
{
	if (move_doing.move.GetLength() == 10) {
		if (OCX.RegisterMove(move_doing.move) == s_false)
			//MessageBox (CString((LPCSTR)(IDS_ERR_TAKE_FIG + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
			return;
	}
	else
		if (OCX.RegisterMove(move_doing.move) == s_false)
			//MessageBox (CString((LPCSTR)(IDS_ERR_DO_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
			;
	UpdateState();
	move_doing.started = false;
	move_doing.move.Empty();
	undo_times = 0;
}

CString CDraughtsView::MoveStrToHistStr(CString* move)
{
	CString str, str0, str1;
	int num;
	if (move->Left(5) == s_white) { str0.LoadString(IDS_WHITE + language); str1 = ": "; }
	else if (move->Left(5) == s_black) { str0.LoadString(IDS_BLACK + language); str1 = ":  "; }
	str = str0.GetAt(0); str += str1;
	int i = 6;
	while (i < move->GetLength()) {
		if (!move_notation) {
			str += ((*move)[i + 3] - '1') + 'a';
			str += ((*move)[i + 1] - '1') + '1';
		}
		else {
			num = ((FCV -1) - ((*move)[i + 1] - '1')) * (FCH / 2) + ((*move)[i + 3] - '1') / 2 + 1;
			str0.Format("%i", num); str += str0;
		}
		if (i != move->GetLength() - 4)
			if (IsJump(move)) str += " X "; else str += " - ";
		else if (i == 6) str += " X";
		i += 5;
	}
	return str;
}

void CDraughtsView::UpdateHistory()
{
	movehistory.DeleteString(movehistory.GetCount() - 1);
	int c = movehistory.GetCount();
	CString history = OCX.GetHistory();
	
	CString move;
	int i = 0, j = 0;
	while (i < history.GetLength()) {
		move.Empty();
		do {
			move += history[i]; i++;
		} while ((i < history.GetLength()) && (history[i] != s_white[0]) && (history[i] != s_black[0]));
		move = move.Left(move.GetLength() - 1);	j++;
		if (j > c) movehistory.AddString(MoveStrToHistStr(&move));
	}
	
	movehistory.Invalidate();
	movehistory.UpdateWindow();
}

void CDraughtsView::UpdateState()
{
	CRect rect (CPoint(board.startx, board.starty), CSize(board.size, board.size));
	RedrawWindow(rect);
	UpdateHistory();
	SetStatusBar();
}

void CDraughtsView::OnMoveGiveUp() 
{
	// TODO: Add your command handler code here
	CString p;
	if (player_on_turn == WHITE) p = s_wmiss;
	else if (player_on_turn == BLACK) p = s_bmiss;
	if (OCX.TryMove(p) == s_true) {
		if (MessageBox (CString((LPCSTR)(IDS_GIVE_UP + language)), CString((LPCSTR)(IDS_CONFIRMATION + language)), MB_ICONQUESTION | MB_YESNO) == IDYES) {
			OCX.RegisterMove(p);
			UpdateState();
		}
	}
	else MessageBox (CString((LPCSTR)(IDS_ERR_GIVE_UP + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
}

void CDraughtsView::OnUpdateMoveGiveUp(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if ((game_running) && (!players.comp[player_on_turn])) pCmdUI->Enable (true);
	else pCmdUI->Enable (false);		
}

void CDraughtsView::DrawFieldsNumbers(CDC * pDC)
{
	int num;
	CString str;
	int font_w = 6, font_h = 12, x, y;
	pDC->SetTextColor (RGB (255,128,0));
	for (int i = FCV - 1; i >= 0; i--)
		for (int j = 0; j < FCH; j++)
			if (((i % 2) && (j % 2)) || ((!(i % 2)) && (!(j % 2)))) {
				num = ((FCV -1) - i) * (FCH / 2) + j / 2 + 1;
				if (num == 10) font_w *= 2;
				str.Format("%i", num);
				x = board.startx + j * board.size / FCH + (board.size / FCH) / 2 - font_w / 2;
				y = board.starty + ((FCV -1) - i) * board.size / FCV + (board.size / FCV) / 2 - font_h / 2;
				pDC->SetBkColor(pDC->GetPixel(x, y));
				pDC->TextOut (x, y, str);
			}
}

void CDraughtsView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (nIDEvent == ID_TIMER) {
		long delay = ::GetTickCount() - old_tick_count;
		old_tick_count += delay; 
		if ((undo_times)  && (players.comp[player_on_turn])) delay = 0;
		if (delay) { 
			ms_count += delay;
			if (ms_count >= 1000) {
				int sec = ms_count / 1000; if (ms_count % 1000 >= 500) sec++;
				time.game += sec;
				if (player_on_turn == WHITE) time.white += sec;
				else if (player_on_turn == BLACK) time.black += sec;
				ms_count = 0;
			}
		}
		DrawTime(GetDC());
		if (!game_running) KillTimer(ID_TIMER);
		if ((players.comp[player_on_turn]) && (!undo_times) && (!move_doing.move.IsEmpty())) {		
			if (move_doing.move != s_false) DoMove();
			else MessageBox (CString((LPCSTR)(IDS_ERR_GET_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
			return;
		}
		if ((!ms_count) && (players.comp[player_on_turn]) && (!undo_times) && (move_doing.move.IsEmpty())) {
				CString str; str.Format("%02i", players.times[player_on_turn]);
				move_doing.move = OCX.GetMove(str);
		}
	}

	CView::OnTimer(nIDEvent);
}

void CDraughtsView::DrawTime(CDC * pDC)
{
	CRect rect;	
	GetClientRect (rect);
	CString text0, text;
	CSize ts;

	pDC->SetBkColor(bkg_color); pDC->SetTextColor (0);
	text.LoadString(IDS_GAME_TIME + language); text += ": ";
	int h = time.game / 3600, m = (time.game % 3600) / 60, s = time.game % 60;
	text0.Format("%i:%02i:%02i ", h, m, s); text += text0;
	ts = pDC->GetTextExtent(text);
	int center = (rect.Height () + rect.Width()) / 2;
	pDC->TextOut (center - ts.cx / 2, rect.Height () / 30, text);
	if (language == 0) text = "W: "; if (language == 1) text = "B: ";
	h = time.white / 3600, m = (time.white % 3600) / 60, s = time.white % 60;
	text0.Format("%i:%02i:%02i ", h, m, s); text += text0;
	ts = pDC->GetTextExtent(text);
	if (player_on_turn == WHITE) pDC->SetBkColor(RGB(255,255,255));
	pDC->TextOut (center - ts.cx, rect.Height () / 30 + ts.cy, text);
	if (language == 0) text = "B: "; if (language == 1) text = ": ";
	h = time.black / 3600, m = (time.black % 3600) / 60, s = time.black % 60;
	text0.Format("%i:%02i:%02i ", h, m, s); text += text0;
	if (player_on_turn == BLACK) pDC->SetBkColor(RGB(255,255,255));
	else pDC->SetBkColor(bkg_color);
	pDC->TextOut (center, rect.Height () / 30 + ts.cy, text);
}

void CDraughtsView::OnSettingsGameMJ() 
{
	// TODO: Add your command handler code here
	must_jump = !must_jump;
	CString must = s_false;
	if (must_jump) must = s_true;
	OCX.SetGameSettings(must);
}

void CDraughtsView::OnUpdateSettingsGameMJ(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (must_jump) pCmdUI->SetCheck(1); else pCmdUI->SetCheck(0);
}

void CDraughtsView::OnSettingsView() 
{
	// TODO: Add your command handler code here
	CViewDlg dialog;
	
	dialog.m_language = language;
	dialog.m_notation = move_notation;
	dialog.m_number_fields = draw_fields_numbers;
	
	dialog.DoModal ();
	
	language = dialog.m_language;
	move_notation = dialog.m_notation;
	draw_fields_numbers = dialog.m_number_fields;	

	my_menu.DestroyMenu();
	if (!language) my_menu.LoadMenu (IDR_MENU_ENG);
	else my_menu.LoadMenu (IDR_MENU_CZ);
	GetParent()->SetMenu (&my_menu);

	Invalidate();
	UpdateWindow();
}

bool CDraughtsView::IsJump(CString * move)
{
	if (move->GetLength() < 15) return false;
	int i1 = (*move)[7] - '1', i2 = (*move)[12] - '1';
	if ((i1 == i2 + 2) || (i1 == i2 - 2)) return true;
	return false;
}

void CDraughtsView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class

//	board.bmp->LoadBitmap (IDB_BITMAP_BOARD);
	bmps.wm->LoadBitmap (IDB_BITMAP_WM);
	bmps.wk->LoadBitmap (IDB_BITMAP_WK);
	bmps.bm->LoadBitmap (IDB_BITMAP_BM);
	bmps.bk->LoadBitmap (IDB_BITMAP_BK);
	bmps.mask->LoadBitmap (IDB_BITMAP_MASK);
	
	//board.dc->CreateCompatibleDC (GetDC());
	//board.dc->SelectObject (board.bmp);
	dcs.figure->CreateCompatibleDC (GetDC());
	dcs.mask->CreateCompatibleDC(dcs.figure);
	dcs.mask->SelectObject (bmps.mask);
	dcs.temp->CreateCompatibleDC(GetDC());

	BITMAP bitmap;
	bmps.mask->GetBitmap (&bitmap);
	CBitmap bm_temp;
	bm_temp.CreateCompatibleBitmap (GetDC(), bitmap.bmWidth, bitmap.bmHeight);
	dcs.temp->SelectObject (&bm_temp);

	CRect rect (0,0,1,1);
	movehistory.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_HASSTRINGS | WS_BORDER, rect, this, ID_MOVEHISTORY);

	my_menu.LoadMenu (IDR_MENU_ENG);
	GetParent()->SetMenu (&my_menu);

	OCX.Create(NULL, 0, CRect(0,0,1,1), this, 0);
}

void CDraughtsView::OnGameSave() 
{
	// TODO: Add your command handler code here
	CFile file;
	if (!file.Open(file_name, CFile::modeCreate | CFile::modeWrite))
		MessageBox (CString((LPCSTR)(IDS_ERR_OPEN_FILE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
	
	CString buffer = SaveGame();

	file.Write(buffer, buffer.GetLength());

	file.Close();
}

void CDraughtsView::OnUpdateGameSave(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (game_running) pCmdUI->Enable (true);
	else pCmdUI->Enable (false);			
}

void CDraughtsView::OnGameOpen() 
{
	// TODO: Add your command handler code here
	if (game_running)
		if (MessageBox (CString((LPCSTR)(IDS_ABORT_GAME + language)), CString((LPCSTR)(IDS_CONFIRMATION + language)), MB_ICONQUESTION | MB_YESNO) == IDNO) return;

	CFileDialog dialog (TRUE, NULL, "");
	
	if (dialog.DoModal() == IDOK) {
		CFile file;
		if (!file.Open(dialog.GetPathName(), CFile::modeRead))
			MessageBox (CString((LPCSTR)(IDS_ERR_OPEN_FILE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
	
		long filesize = file.GetLength();
		char *buffer = NULL;
		buffer = (char*)malloc(filesize + 1);
		if (buffer == NULL)
			MessageBox (CString((LPCSTR)(IDS_ERR_READ_FILE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);

		long res = file.Read(buffer, filesize);
		file.Close();
		if (res != filesize)
			MessageBox (CString((LPCSTR)(IDS_ERR_READ_FILE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
		
		buffer[filesize] = 0;
		if (!LoadGame(&((CString)buffer)))
			MessageBox (CString((LPCSTR)(IDS_ERR_LOAD_GAME + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);

		free(buffer);

		file_name = dialog.GetPathName();
		AfxGetMainWnd()->SetWindowText((CString)AfxGetAppName() + " - " + file_name);
	}
}

void CDraughtsView::OnGameSaveAs() 
{
	// TODO: Add your command handler code here
	CFileDialog dialog (FALSE, NULL, file_name);

	if (dialog.DoModal() == IDOK) {
		CFile file;
		if (!file.Open(dialog.GetPathName(), CFile::modeCreate | CFile::modeWrite))
			MessageBox (CString((LPCSTR)(IDS_ERR_OPEN_FILE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
	
		CString buffer = SaveGame();

		file.Write(buffer, buffer.GetLength());
		file.Close();

		file_name = dialog.GetPathName();
		AfxGetMainWnd()->SetWindowText((CString)AfxGetAppName() + " - " + file_name);
	}
}

void CDraughtsView::OnUpdateGameSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if (game_running) pCmdUI->Enable (true);
	else pCmdUI->Enable (false);				
}

bool CDraughtsView::LoadGame(CString * game)
{
	if ((*game).GetLength() < 10) return false;
	int i = 0;
	if ((*game)[i] == '1') players.comp[WHITE] = true; else players.comp[WHITE] = false; i++;
	players.iqs[WHITE] = (*game)[i] - '0'; i++;
	players.times[WHITE] = ((*game)[i] - '0') * 10 + (*game)[i + 1] - '0'; i += 2;
	if ((*game)[i] == '1') players.comp[BLACK] = true; else players.comp[BLACK] = false; i++;
	players.iqs[BLACK] = (*game)[i] - '0'; i++;
	players.times[BLACK] = ((*game)[i] - '0') * 10 + (*game)[i + 1] - '0'; i += 2;
	if ((*game)[i] == '1') must_jump = true; else must_jump = false; i += 2;

	game_running = false;
	OnGameNew();

	time.game = atol((LPCSTR)(*game).Mid(i, 5)); i += 5;
	time.white = atol((LPCSTR)(*game).Mid(i, 5)); i += 5;
	time.black = atol((LPCSTR)(*game).Mid(i, 5)); i += 6;
	
	CString move;
	int j = 0;
	while (i < (*game).GetLength()) {
		move.Empty();
		do {
			move += (*game)[i]; i++;
		} while ((i < (*game).GetLength()) && ((*game)[i] != s_white[0]) && ((*game)[i] != s_black[0]));
		move = move.Left(move.GetLength() - 1);	j++;
		if (move.GetLength() == 10) {
			if (OCX.RegisterMove(move) == s_false) {
				MessageBox (CString((LPCSTR)(IDS_ERR_TAKE_FIG + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
				return false;
			}
		}
		else
			if (OCX.RegisterMove(move) == s_false) {
				MessageBox (CString((LPCSTR)(IDS_ERR_DO_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
				return false;
			}
	}
	UpdateState();
	return true;
}

CString CDraughtsView::SaveGame()
{
	CString game = "", str;
	
	if (players.comp[WHITE]) str = "1"; else str = "0"; game += str;
	str.Format("%i%02i", players.iqs[WHITE], players.times[WHITE]); game += str;
	if (players.comp[BLACK]) str = "1"; else str = "0"; game += str;
	str.Format("%i%02i", players.iqs[BLACK], players.times[BLACK]); game += str;
	if (must_jump) str = "1"; else str = "0"; game += str;
	game += ' ';
	str.Format("%05li%05li%05li", time.game, time.white, time.black); game += str;
	game += ' ';
	game += OCX.GetHistory();

	return game;
}

void CDraughtsView::OnObjectsCore() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("Core_main");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsManager() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("Manager");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsReferee() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("Referee");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsWhite() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("White");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsBlack() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("Black");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsState() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("State");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsBoard() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("Board");
	dialog.DoModal();
}

void CDraughtsView::OnObjectsHistory() 
{
	// TODO: Add your command handler code here
	CDataDlg dialog;	
	dialog.m_richedit = OCX.DataAsText("History");
	dialog.DoModal();
}

BOOL CDraughtsView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return TRUE;

	//return CView::OnEraseBkgnd(pDC);
}

void CDraughtsView::OnHelpHelp() 
{
	// TODO: Add your command handler code here
	if (!language) FileToDialog("help_eng.txt"); else FileToDialog("help_cz.txt");
}

void CDraughtsView::OnHelpRules() 
{
	// TODO: Add your command handler code here
	if (!language) FileToDialog("rules_eng.txt"); else FileToDialog("rules_cz.txt");
}

void CDraughtsView::FileToDialog(CString file_name)
{
	CDataDlg dialog;
	
	CFile file;
	if (!file.Open(file_name, CFile::modeRead)) return;
	long filesize = file.GetLength();
	char *buffer = NULL;
	buffer = (char*)malloc(filesize + 1);
	if (buffer == NULL) return;
	long res = file.Read(buffer, filesize);
	file.Close();
	if (res != filesize) { free(buffer); return; }
	buffer[filesize] = 0;
	dialog.m_richedit = (CString)buffer;
	
	dialog.DoModal();
	
	free(buffer);
}

void CDraughtsView::ShowPositions(int x, int y, CString *list)
{
	CString move;
	if (player_on_turn == WHITE) move = s_white;
	else if (player_on_turn == BLACK) move = s_black;
	move += ' '; move += y / 10 + '0'; move += y % 10 + '1'; move += x / 10 + '0'; move += x % 10 + '1';
				
	CString mv_list = *list;
	CString pos_list = "";
	bool search = true;
	while (search) {
		int index = mv_list.Find(move);
		if (index != -1) {
			int index0 = index + move.GetLength();
			while ((index0 + 4 < mv_list.GetLength()) && (mv_list[index0 + 1] != move[0])) {
				pos_list += mv_list[index0 + 2]; pos_list += mv_list[index0 + 4]; index0 += 5;
			}
			mv_list = mv_list.Right(mv_list.GetLength() - (index0 + 1));
		}
		else search = false;
	}

	int c = 0, i, j;
	CRect rect;
	CBrush brush (RGB(255,255,0));
	while (c < pos_list.GetLength()) {
		i = (FCV - 1) - (pos_list[c] - '1'); j = pos_list[c + 1] - '1'; c += 2;
		rect.left = board.startx + j * board.size / FCH; rect.right = rect.left + board.size / FCH;
		rect.top = board.starty + i * board.size / FCV; rect.bottom = rect.top + board.size / FCV;
		GetDC()->FrameRect(rect, &brush);
		rect.left++; rect.right--; rect.top++; rect.bottom--;
		GetDC()->FrameRect(rect, &brush);
	}
}

void CDraughtsView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (game_running) {
		if (!players.comp[player_on_turn]) {
			if (!move_doing.move.IsEmpty()) DoMove ();
		}
		else if (undo_times) {
			move_doing.move.Empty();
			CString str; str.Format("%02i", players.times[player_on_turn]);
			move_doing.move = OCX.GetMove(str);
			if (move_doing.move != s_false) DoMove();
			else MessageBox (CString((LPCSTR)(IDS_ERR_GET_MOVE + language)), CString((LPCSTR)(IDS_ERROR + language)), MB_ICONERROR);
		}
	}
			
	CView::OnRButtonDown(nFlags, point);
}

void CDraughtsView::OnOcxAbout() 
{
	// TODO: Add your command handler code here
	OCX.AboutBox();
}
