// DraughtsView.h : interface of the CDraughtsView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAUGHTSVIEW_H__F706A34E_1209_11D4_BF1A_861AEFF7C030__INCLUDED_)
#define AFX_DRAUGHTSVIEW_H__F706A34E_1209_11D4_BF1A_861AEFF7C030__INCLUDED_

#include "outrataj.h"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDraughtsView : public CView
{
protected: // create from serialization only
	CDraughtsView();
	DECLARE_DYNCREATE(CDraughtsView)

// Attributes
public:
	CDraughtsDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDraughtsView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDraughtsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDraughtsView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnGameNew();
	afx_msg void OnMoveMove();
	afx_msg void OnUpdateMoveMove(CCmdUI* pCmdUI);
	afx_msg void OnMoveSuggest();
	afx_msg void OnUpdateMoveSuggest(CCmdUI* pCmdUI);
	afx_msg void OnSettingsPlayers();
	afx_msg void OnMoveUndo();
	afx_msg void OnUpdateMoveUndo(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMoveRedo();
	afx_msg void OnUpdateMoveRedo(CCmdUI* pCmdUI);
	afx_msg void OnMoveGiveUp();
	afx_msg void OnUpdateMoveGiveUp(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSettingsGameMJ();
	afx_msg void OnUpdateSettingsGameMJ(CCmdUI* pCmdUI);
	afx_msg void OnSettingsView();
	afx_msg void OnGameSave();
	afx_msg void OnUpdateGameSave(CCmdUI* pCmdUI);
	afx_msg void OnGameOpen();
	afx_msg void OnGameSaveAs();
	afx_msg void OnUpdateGameSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnObjectsCore();
	afx_msg void OnObjectsManager();
	afx_msg void OnObjectsReferee();
	afx_msg void OnObjectsWhite();
	afx_msg void OnObjectsBlack();
	afx_msg void OnObjectsState();
	afx_msg void OnObjectsBoard();
	afx_msg void OnObjectsHistory();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnHelpHelp();
	afx_msg void OnHelpRules();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnOcxAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void ShowPositions(int x, int y, CString *list);
	void FileToDialog(CString file_name);
	CString SaveGame();
	bool LoadGame(CString *game);
	CString file_name;
	bool IsJump(CString* move);
	COutrataj OCX;
	void DrawTime (CDC* pDC);
	char FCV, FCH, WHITE, BLACK;
	long old_tick_count;
	int ms_count;
	bool must_jump;
	char move_notation;
	bool draw_fields_numbers;
	void DrawFieldsNumbers (CDC* pDC);
	void UpdateState();
	bool game_ended_mesbox;
	void UpdateHistory ();
	CString MoveStrToHistStr (CString* move);
	void DoMove ();
	void SetStatusBar ();
	CListBox movehistory;
	struct {
		char iqs[2];
		bool comp[2];
		char times[2];
	} players;
	int player_on_turn;
	bool game_running;
	void DrawFigure (CDC* pDC, int i, int j);
	void DrawBoard (CDC* pDC);
	struct Smove_doing {
		CString move;
		bool started;
	} move_doing;
	struct {
		CDC* dc;
		CBitmap* bmp;
		int size;
		int startx;
		int starty;
		bool redraw;
	} board;
	struct {
		CDC* figure;
		CDC* mask;
		CDC* temp;
	} dcs;
	COLORREF bkg_color;
	struct {
		CBitmap* wm;
		CBitmap* wk;
		CBitmap* bm;
		CBitmap* bk;
		CBitmap* mask;
	} bmps;
	int undo_times;
	struct {
		long game;
		long white;
		long black;
	} time;
	CString s_true, s_false, s_white, s_black, s_wdraw, s_bdraw, s_wmiss, s_bmiss;
	CMenu my_menu;
};

#ifndef _DEBUG  // debug version in DraughtsView.cpp
inline CDraughtsDoc* CDraughtsView::GetDocument()
   { return (CDraughtsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DRAUGHTSVIEW_H__F706A34E_1209_11D4_BF1A_861AEFF7C030__INCLUDED_)
