// OutratajCtl.cpp : Implementation of the COutratajCtrl ActiveX Control class.

#include "stdafx.h"
#include "outrataj.h"
#include "OutratajPpg.h"

#include "res.h"
#include "datastructs.h"
#include "stuff.h"
#include "state.h"
#include "referee.h"
#include "player.h"
#include "manager.h"
#include "core_main.h"

#include "OutratajCtl.h"

extern class CCore_main Core;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

struct SThread_Params { 
	CMove* move;
	TColor p;
	bool completed;
	int return_code;
	bool running;
} thread_params;

UINT ThreadProc(LPVOID pParam)
{
	SThread_Params* params = (SThread_Params*)pParam;

	if (Core.Get_Manager()->Get_Move (params->move, params->p)) {
		params->return_code = 0; params->completed = true; return 0;
	}
	else { params->return_code = -1; params->completed = true; return -1; }
}

IMPLEMENT_DYNCREATE(COutratajCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(COutratajCtrl, COleControl)
	//{{AFX_MSG_MAP(COutratajCtrl)
	// NOTE - ClassWizard will add and remove message map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(COutratajCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(COutratajCtrl)
	DISP_FUNCTION(COutratajCtrl, "InitGame", InitGame, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(COutratajCtrl, "InitPlayer", InitPlayer, VT_BSTR, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "OnMove", OnMove, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(COutratajCtrl, "GetMove", GetMove, VT_BSTR, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "TryMove", TryMove, VT_BSTR, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "RegisterMove", RegisterMove, VT_BSTR, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "UndoMove", UndoMove, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(COutratajCtrl, "GetSituation", GetSituation, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(COutratajCtrl, "SetSituation", SetSituation, VT_BSTR, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "RedoMove", RedoMove, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(COutratajCtrl, "GetHistory", GetHistory, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(COutratajCtrl, "SetGameSettings", SetGameSettings, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "DataAsText", DataAsText, VT_BSTR, VTS_BSTR)
	DISP_FUNCTION(COutratajCtrl, "GetAllMoves", GetAllMoves, VT_BSTR, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(COutratajCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(COutratajCtrl, COleControl)
	//{{AFX_EVENT_MAP(COutratajCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(COutratajCtrl, 1)
	PROPPAGEID(COutratajPropPage::guid)
END_PROPPAGEIDS(COutratajCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(COutratajCtrl, "OUTRATAJ.OutratajCtrl.1",
	0x9343266e, 0x3bc3, 0x11d4, 0xbf, 0x1b, 0xb4, 0x3b, 0xd5, 0x25, 0x68, 0x26)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(COutratajCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DOutrataj =
		{ 0x93432683, 0x3bc3, 0x11d4, { 0xbf, 0x1b, 0xb4, 0x3b, 0xd5, 0x25, 0x68, 0x26 } };
const IID BASED_CODE IID_DOutratajEvents =
		{ 0x93432684, 0x3bc3, 0x11d4, { 0xbf, 0x1b, 0xb4, 0x3b, 0xd5, 0x25, 0x68, 0x26 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwOutratajOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(COutratajCtrl, IDS_OUTRATAJ, _dwOutratajOleMisc)


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::COutratajCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for COutratajCtrl

BOOL COutratajCtrl::COutratajCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_OUTRATAJ,
			IDB_OUTRATAJ,
			afxRegInsertable | afxRegApartmentThreading,
			_dwOutratajOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::COutratajCtrl - Constructor

COutratajCtrl::COutratajCtrl()
{
	InitializeIIDs(&IID_DOutrataj, &IID_DOutratajEvents);

	// TODO: Initialize your control's instance data here.
	s_true = "TRUE";
	s_false = "FALSE";
	s_white = "WHITE";
	s_black = "BLACK";
	s_wdraw = "WDRAW";
	s_bdraw = "BDRAW";
	s_wmiss = "WMISS";
	s_bmiss = "BMISS";
}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::~COutratajCtrl - Destructor

COutratajCtrl::~COutratajCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::OnDraw - Drawing function

void COutratajCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->Ellipse(rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::DoPropExchange - Persistence support

void COutratajCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::OnResetState - Reset control to default state

void COutratajCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl::AboutBox - Display an "About" box to the user

void COutratajCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_OUTRATAJ);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// COutratajCtrl message handlers

BSTR COutratajCtrl::InitGame() 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	if (Core.Get_Manager()->New_Game()) {
		thread_params.completed = thread_params.running = false;
		strResult =  s_true;
	}

	return strResult.AllocSysString();
}

BSTR COutratajCtrl::InitPlayer(LPCTSTR settings) 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	int d = settings[6] - '1'; //difficulty, 1 - 9
	if ((d >= 0) && (d <= 8) && (settings[5] == ' '))
		if (Str_Cmp(s_white, settings, 0))
			if (Core.Get_Manager()->Set_Player(WHITE, COMPUTER, d)) strResult = s_true;
		if (Str_Cmp(s_black, settings, 0))
			if (Core.Get_Manager()->Set_Player(BLACK, COMPUTER, d)) strResult = s_true;

	return strResult.AllocSysString();
}

bool COutratajCtrl::Str_Cmp(CString& pat, const char* s, int pos)
{
	int i = 0;
	while (i < pat.GetLength()) { if (pat[i] != s[pos + i]) return false; i++; }
	return true;
}

BSTR COutratajCtrl::OnMove() 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	if (Core.Get_State()->Whos_On_Turn() == WHITE) strResult = s_white; else strResult = s_black;

	return strResult.AllocSysString();
}

BSTR COutratajCtrl::GetMove(LPCTSTR time) // 0 - no force, < 200 ms => probably error
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	int ms = 2000;
	if ((time[0] >= '0') && (time[0] <= '9') && (time[1] >= '0') && (time[1] <= '9'))
		ms = ((time[0] - '0') * 10 + (time[1] - '0')) * 1000;
	if (!ms) ms = 1000000;
	CMove move;
	TColor p = Core.Get_State()->Whos_On_Turn ();
	thread_params.move = &move; thread_params.p = p; thread_params.completed = false;
	thread_params.return_code = 0;
	AfxBeginThread(ThreadProc, &thread_params);
	DWORD time_out = ::GetTickCount() + ms;
	while ((::GetTickCount() < time_out) && (!thread_params.completed)) ;
	Core.Get_Manager()->Force_Move(&move, p); 
	while (!thread_params.completed) ;
	if (thread_params.return_code == 0) CMove2Str (&move, strResult);
	else
		if (Core.Get_State()->Game_Ended())
			if (Core.Get_State()->Victory ())
				if (Core.Get_State()->Get_Winner () == WHITE) strResult = s_bmiss;
				else strResult = s_wmiss;
			else
				if (p == WHITE) strResult = s_wdraw;
				else strResult = s_bdraw;
	
	return strResult.AllocSysString();
}

void COutratajCtrl::CMove2Str(CMove * m, CString & str)
{
	if (m->Get_Player() == WHITE) str = s_white; else str = s_black; str += ' ';
	char first_index = '1';
	CPosition pos;
	for (int i = 0; i < m->Number_Of_Positions (); i++) {
		pos = m->Get_Position (i);
		str += pos.Get_Vertical_Index () / 10 + '0';
		str += pos.Get_Vertical_Index () % 10 + first_index;
		str += pos.Get_Horizontal_Index () / 10 + '0';
		str += pos.Get_Horizontal_Index () % 10 + first_index;
		if (i != m->Number_Of_Positions() - 1) str += ' ';
	}
}

BSTR COutratajCtrl::TryMove(LPCTSTR move) 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	TColor p = Core.Get_State()->Whos_On_Turn ();
	if ((((Str_Cmp (s_white, move, 0)) && (p == WHITE)) || ((Str_Cmp (s_black, move, 0)) && (p == BLACK))) &&
		(move[5] == ' ')) {
		CMove mv;
		if (Str2CMove ((CString)move, mv))
			if (mv.Number_Of_Positions() == 1) {
				if (Core.Get_Manager()->Remove_Figure(mv.Get_Position(0), false)) 
					strResult = s_true;
			}
			else if (Core.Get_Manager()->Check_Move (p, &mv)) strResult = s_true;
			else if (Core.Get_Manager()->Get_Forced_Move (&mv)) CMove2Str (&mv, strResult);
	}
	else if (Str_Cmp (s_wmiss, move, 0)) {
		if (Core.Get_Manager()->End_Game(p, true, WHITE, false)) strResult = s_true;
	}
	else if (Str_Cmp (s_bmiss, move, 0)) {
		if (Core.Get_Manager()->End_Game(p, true, BLACK, false)) strResult = s_true;
	}

	return strResult.AllocSysString();
}

bool COutratajCtrl::Str2CMove(CString & str, CMove & move)
{
	bool ret = false;
	char first_index = '1';
	CPosition pos;
	if (Str_Cmp (s_white, str, 0)) move.Set_Player(WHITE);
	else if (Str_Cmp (s_black, str, 0)) move.Set_Player(BLACK);
	int i = 6, num, l = str.GetLength();
	while (i < l) {
		if (l < i + 4) return false;
		num = (str[i] - '0') * 10 + str[i + 1] - first_index; i += 2;
		pos.Set_Vertical_Index (num);
		num = (str[i] - '0') * 10 + str[i + 1] - first_index; i += 3;
		if (i - 1 < l) if (str[i - 1] != ' ') return false;
		pos.Set_Horizontal_Index (num);
		if (!move.Insert_Position (pos)) return false;
		ret = true;
	}
	return ret;
}

BSTR COutratajCtrl::RegisterMove(LPCTSTR move) 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	TColor p = Core.Get_State()->Whos_On_Turn ();
	if ((((Str_Cmp (s_white, move, 0)) && (p == WHITE)) || ((Str_Cmp (s_black, move, 0)) && (p == BLACK))) &&
		(move[5] == ' ')) {
		CMove mv;
		if (Str2CMove ((CString)move, mv))
			if (mv.Number_Of_Positions() == 1) {
				if (Core.Get_Manager()->Remove_Figure(mv.Get_Position(0), true)) 
					strResult = s_true;
			}
			else if (Core.Get_Manager()->Execute_Move (p, &mv)) strResult = s_true;
	}
	else if (Str_Cmp (s_wmiss, move, 0)) {
		if (Core.Get_Manager()->End_Game(p, true, WHITE, true)) strResult = s_true;
	}
	else if (Str_Cmp (s_bmiss, move, 0)) {
		if (Core.Get_Manager()->End_Game(p, true, BLACK, true)) strResult = s_true;
	}
	
	return strResult.AllocSysString();
}

BSTR COutratajCtrl::UndoMove() 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	if (Core.Get_Manager()->Undo_Move()) strResult =  s_true;

	return strResult.AllocSysString();
}

BSTR COutratajCtrl::GetSituation() 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	TColor p = Core.Get_State()->Whos_On_Turn ();
	if (Core.Get_State()->Game_Ended())
		if (Core.Get_State()->Victory ())
			if (Core.Get_State()->Get_Winner () == WHITE) strResult = s_bmiss;
			else strResult = s_wmiss;
		else
			if (p == WHITE) strResult = s_wdraw;
			else strResult = s_bdraw;
	else
		if (p == WHITE) strResult = s_white; else strResult = s_black;
	CFigure* fig;
	for (int i = 0; i < FIELD_COUNT_VERTICAL; i++)
		for (int j = 0; j < FIELD_COUNT_HORIZONTAL; j++) {
			strResult += ' ';
			fig = Core.Get_State()->Get_Board()->Get_Figure (CPosition (i, j));
			if (fig == NULL) strResult += "00";
			else {
				if (fig->Get_Color () == WHITE) strResult += '0'; else strResult += '1';
				if (fig->Get_Type () == KING) strResult += '2';	else strResult += '1';
			}
		}
	
	return strResult.AllocSysString();
}

BSTR COutratajCtrl::SetSituation(LPCTSTR game) 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_true;
	if (Core.Get_Manager()->New_Game()) {
		if (Str_Cmp(s_white, game, 0)) Core.Get_State()->Set_Player_On_Turn (WHITE);
		else if (Str_Cmp(s_black, game, 0)) Core.Get_State()->Set_Player_On_Turn (BLACK);
		else if (Str_Cmp(s_wdraw, game, 0)) {
			Core.Get_State()->Set_Game_Ended (true);
			Core.Get_State()->Set_Player_On_Turn (WHITE);
		}
		else if (Str_Cmp(s_bdraw, game, 0)) {
			Core.Get_State()->Set_Game_Ended (true);
			Core.Get_State()->Set_Player_On_Turn (BLACK);
		}
		else if (Str_Cmp(s_bmiss, game, 0)) {
			Core.Get_State()->Set_Game_Ended (true);
			Core.Get_State()->Set_Victory (true);
			Core.Get_State()->Set_Winner (WHITE);
		}
		else if (Str_Cmp(s_wmiss, game, 0)) {
			Core.Get_State()->Set_Game_Ended (true);
			Core.Get_State()->Set_Victory (true);
			Core.Get_State()->Set_Winner (BLACK);
		}
		else strResult = s_false;
		if (strResult == s_true) {
			int index, first = 5;
			for (int i = 0; i < FIELD_COUNT_VERTICAL; i++) {
				for (int j = 0; j < FIELD_COUNT_HORIZONTAL; j++) {
					index = first + (i * FIELD_COUNT_HORIZONTAL + j) * 3;
					if (game[index] != ' ') strResult = s_false;
					else {
						if (game[index + 1] == '0') {
							if (game[index + 2] == '0')
								Core.Get_State()->Remove_Figure (CPosition (i, j));
							else if (game[index + 2] == '1')
								Core.Get_State()->Put_Figure (CPosition (i, j), WHITE, MAN);
							else if (game[index + 2] == '2')
								Core.Get_State()->Put_Figure (CPosition (i, j), WHITE, KING);
							else strResult = s_false;
						}
						else if (game[index + 1] == '1') {
							if (game[index + 2] == '1')
								Core.Get_State()->Put_Figure (CPosition (i, j), BLACK, MAN);
							else if (game[index + 2] == '2')
								Core.Get_State()->Put_Figure (CPosition (i, j),BLACK, KING);
							else strResult = s_false;
						}
						else strResult = s_false;
					}
					if (strResult == s_false) break;
				}
				if (strResult == s_false) break;
			}
		}
	}
	else strResult = s_false;

	return strResult.AllocSysString();
}

BSTR COutratajCtrl::RedoMove() 
{
	CString strResult;
	// TODO: Add your dispatch handler code here
	strResult = s_false;
	if (Core.Get_Manager()->Redo_Move()) strResult =  s_true;

	return strResult.AllocSysString();
}

BSTR COutratajCtrl::GetHistory() 
{
	CString strResult = "";
	// TODO: Add your dispatch handler code here
	CHistory* history = Core.Get_State()->Get_History();
	CMove* move;
	CString str = "";
	for (int i = 0; i < history->Number_Of_Items(); i++) {
		move = history->Get_Value(i);
		CMove2Str (move, str);
		strResult += str;
		strResult += ' ';
	}

	return strResult.AllocSysString();
}

void COutratajCtrl::SetGameSettings(LPCTSTR mustjump) 
{
	// TODO: Add your dispatch handler code here
	bool must = false;
	if (Str_Cmp(s_true, mustjump, 0)) must = true;
	Core.Get_Manager()->Set_Game_Settings(must);
}

BSTR COutratajCtrl::DataAsText(LPCTSTR object) 
{
	CString strResult = s_false;
	// TODO: Add your dispatch handler code here
	char buffer[1000]; buffer[0] = 0;
	if ((CString)object == "Core_main") Core.DataAsText(buffer);
	else if ((CString)object == "Manager") Core.Get_Manager()->DataAsText(buffer, 0);
	else if ((CString)object == "Referee") Core.Get_Manager()->DataAsText(buffer, 1);
	else if ((CString)object == "White") Core.Get_Manager()->DataAsText(buffer, 2);
	else if ((CString)object == "Black") Core.Get_Manager()->DataAsText(buffer, 3);
	else if ((CString)object == "State") Core.Get_State()->DataAsText(buffer);
	else if ((CString)object == "Board") Core.Get_State()->Get_Board()->DataAsText(buffer);
	else if ((CString)object == "History") Core.Get_State()->Get_History()->DataAsText(buffer);

	if (buffer[0]) {
		strResult.Empty();
		for (int i = 0; buffer[i]; i++) {
			if (buffer[i] == '#') { strResult += "\n"; }
			else strResult += buffer[i];
		}
	}

	return strResult.AllocSysString();
}

BSTR COutratajCtrl::GetAllMoves() 
{
	CString strResult = s_false;
	// TODO: Add your dispatch handler code here
	m_CList<CMove*> move_list;
	if (Core.Get_Manager()->Get_All_Moves(Core.Get_State()->Whos_On_Turn (), &move_list)) {
		CMove* move;
		CString str = "";
		strResult = "";
		for (int i = 0; i < move_list.Number_Of_Items(); i++) {
			move = move_list.Get_Value(i);
			CMove2Str (move, str);
			strResult += str;
			strResult += ' ';
		}
	}

	return strResult.AllocSysString();
}
