///////////////////////////
// WINDOWS SPECIFIC PART //

#include "stdafx.h"

///////////////////////////

#include "res.h"
#include "datastructs.h"
#include "stuff.h"
#include "state.h"
#include "referee.h"
#include "player.h"
#include "manager.h"
#include "core_main.h"

bool CCore_main::Create ()
{
	Manager = NULL;
	Manager = new CManager ();
	if (Manager == NULL) return false;
	Referee = NULL;
	Referee = new CReferee ();
	if (Referee == NULL) return false;
	State = NULL;
	State = new CState ();
	if (State == NULL) return false;
	if (!State->Create (true)) return false;
	Manager->Set_Referee (Referee);
	Referee->Set_State (State);
	return true;
}

CCore_main::~CCore_main ()
{
	delete State;
	delete Referee;
	delete Manager;
}

void CCore_main::DataAsText(char* text)
{
	strcat (text, "Core_main:##");
	strcat(text, "Manager: "); if (Manager != NULL) strcat(text, "OK#"); else strcat(text, "NULL#");
	strcat(text, "Referee: "); if (Referee != NULL) strcat(text, "OK#"); else strcat(text, "NULL#");
	strcat(text, "State: "); if (State != NULL) strcat(text, "OK#"); else strcat(text, "NULL#");
}
