// classes of the data structures - a list, a tree

#ifndef DATASTRUCTS_INCLUDED_
#define DATASTRUCTS_INCLUDED_

// class of a list

template<class T>
class m_CList {
protected:
	struct SItem {
		T value;
		SItem* next;
	};
	SItem* head;
	int number_items;
public:
	m_CList () { head = NULL; number_items = 0; }
	~m_CList ();
	void Clear ();
	bool Empty () const { return (number_items == 0); }
	int Number_Of_Items () const { return number_items; }
	T Get_Value (int) const;
	bool Insert_Value (T);
	void Remove_Item (int); // removes item at position, DOES NOT delete the value in the item
	const m_CList& operator = (const m_CList&); // copies list, DOES NOT copy values, only items
};

template<class T> m_CList<T>::~m_CList ()
{
	Clear ();
}

template<class T> void m_CList<T>::Clear ()
{
	SItem* p;
	while (head != NULL) {
		p = head;
		head = head->next;
		delete p;
	}
	number_items = 0;
}

template<class T> T m_CList<T>::Get_Value (int index) const
{
	SItem* current = head;
	for (int i = 0; i != index; i++)
		current = current->next;
	return current->value;
}

template<class T> bool m_CList<T>::Insert_Value (T new_value)
{
	SItem* new_item = NULL;
	new_item = new SItem;
	if (new_item == NULL) return false;
	new_item->value = new_value;
	if (number_items == 0) {
		new_item->next = head;
		head = new_item;
	}
	else {
		SItem* current = head;
		for (int i = 0; i != number_items - 1; i++)
			current = current->next;
		new_item->next = current->next;
		current->next = new_item;
	}
	number_items++;
	return true;
}

template<class T> void m_CList<T>::Remove_Item (int index)
{
	SItem* p;
	if (index == 0) {
		p = head;
		head = head->next;
		delete p;
	}
	else {
		SItem* current = head;
		for (int i = 0; i != index - 1; i++)
			current = current->next;
		p = current->next;
		current->next = current->next->next;
		delete p;
	}
	number_items--;
}

template<class T> const m_CList<T>& m_CList<T>::operator = (const m_CList<T>& list)
{
	if (this != &list) {
		Clear ();
		for (int i = 0; i != list.Number_Of_Items (); i++)
			Insert_Value (list.Get_Value (i));
	}
	return *this;
}

// class of a tree node

template<class T>
class m_CTree_Node {
	T value;
	m_CList<m_CTree_Node<T>*>* sons;
public:
	m_CTree_Node (T v) { sons = NULL; value = v; }
	~m_CTree_Node () { delete sons; }
	bool Create ();
	T Get_Value () const { return value; }
	m_CList<m_CTree_Node<T>*>* Get_List_Of_Sons () const { return sons; }
};

template<class T> bool m_CTree_Node<T>::Create ()
{
	sons = NULL;
	sons = new m_CList<m_CTree_Node<T>*>;
	if (sons == NULL) return false;
	return true;
}

#endif