// class of manager which WAS SUPPOSED to manage all work around and provides function interface for the view

#ifndef MANAGER_INCLUDED_
#define MANAGER_INCLUDED_

class CManager {
	CReferee* referee;
	struct {
		CPlayer* objects[PLAYER_COUNT];
		TPlayer_Type types[PLAYER_COUNT];
		int iqs[PLAYER_COUNT];
	} players_table;
	bool Reset_Players ();
	void Change_Player_On_Turn (TColor);
public:
	CManager ();
	~CManager ();
	void Set_Referee (CReferee* p_referee) { referee = p_referee; }
	bool New_Game ();
	bool Set_Player (TColor c, TPlayer_Type t, int);
	bool Check_Move (TColor p, CMove* m) const { return referee->Check_Move (m, p); }
	bool Execute_Move (TColor, CMove*);
	bool Remove_Figure (CPosition& pos, bool really) { return referee->Remove_Figure (pos, really); }
	bool Get_Move (CMove*, TColor c);
	bool Undo_Move () { return referee->Back_Move(); }
	bool Get_Forced_Move(CMove* move) { return referee->Get_Forced_Move(move); }
	bool End_Game (TColor c, bool vict, TColor loser, bool really) { return referee->End_Game (c, vict, loser, really); }
	bool Redo_Move() { return referee->Forward_Move(); }
	bool Force_Move(CMove*, TColor c);
	void Set_Game_Settings (bool must_jump) { referee->Set_Must_Jump(must_jump); }
	bool Get_Game_Settings() const { return referee->Get_Must_Jump(); }
	void DataAsText(char*, int);
	bool Get_All_Moves (TColor c, m_CList<CMove*>* ml) { return referee->Get_All_Moves(c, ml, NULL); }
};

#endif