// class of the referee which handles the rules and executes changes of the state

#ifndef REFEREE_INCLUDED_
#define REFEREE_INCLUDED_

class CReferee {
	CState* state;
	m_CList<CMove*> move_list;
	char last_move_mistake; // 0 - no mistake, 1 - forgotten jump, 2 - no complete multi-jump
	m_CList<CPosition> last_move_mistake_positions;
	bool Get_All_Jumps_From_Position (m_CList<CMove*>*, CMove*, CPosition&, char, CState*, TColor, TFigure_Type);
	bool Get_All_Moves_From_Position (CPosition&, m_CList<CMove*>*, CState*);
	bool Change_To_King (TColor, CPosition&);
	void Move_Filter (m_CList<CMove*>*);
	bool Set_Move_Mistakes (CMove*);
	bool must_jump;
	int nojump_move_count;
	CHistory undo_list;
	bool Play_Move_List (m_CList<CMove*>*);
public:
	CReferee ();
	~CReferee ();
	void Set_State (CState* p_state) { state = p_state; }
	void Create_New_Game ();
	void Set_Player_On_Turn (TColor c) { state->Set_Player_On_Turn (c); }
	TColor Whos_On_Turn () const { return state->Whos_On_Turn (); }
	bool Check_Move (CMove*, TColor);
	bool Execute_Move (CMove*, CState*);
	bool Remove_Figure (CPosition& pos, bool);
	bool Get_All_Moves (TColor, m_CList<CMove*>*, CState*);
	bool Get_All_States (TColor, m_CList<CState*>*, CState*);
	bool Get_Game_Ended (bool&);
	bool Back_Move ();
	bool Get_Forced_Move(CMove*);
	bool End_Game (TColor, bool, TColor, bool);
	bool Forward_Move ();
	void Clear_Undo_List();
	void Set_Must_Jump(bool must) { must_jump = must; }
	bool Get_Must_Jump() const { return must_jump; }
	void DataAsText(char*);
};

#endif