// class of the state of the game

#ifndef STATE_INCLUDED_
#define STATE_INCLUDED_

class CState {
	CBoard board;
	CFigure white_man, white_king, black_man, black_king;
	TColor player_on_turn;
	CMove last_move;
	bool game_ended, victory;
	TColor winner;
	CHistory* history;
	int eval_value;
public:
	CState ();
	~CState ();
	bool Create (bool);
	CBoard* Get_Board () { return &board; }
	void Reset (); // reset state in the initial state
	CFigure* Remove_Figure (CPosition&);
	void Put_Figure (CPosition&, CFigure*);
	void Put_Figure (CPosition& pos, TColor c, TFigure_Type t);
	void Change_To_King (CPosition&);
	TColor Whos_On_Turn () const { return player_on_turn; }
	void Set_Player_On_Turn (TColor c) { player_on_turn = c; }
	CMove* Get_Last_Move () { return &last_move; }
	bool Set_Last_Move (CMove*);
	const CState& operator = (CState&);
	int Get_Eval_Value () const { return eval_value; }
	void Set_Eval_Value (int v) { eval_value = v; }
	void Evaluate (int, int);
	bool Victory () const { return victory; }
	bool Game_Ended () const {return game_ended; }
	TColor Get_Winner () const { return winner; }
	void Set_Game_Ended (bool b) { game_ended = b; }
	void Set_Victory (bool b) { victory = b; }
	void Set_Winner (TColor c) { winner = c; }
	CHistory* Get_History () const { return history; }
	void DataAsText(char*);
};

#endif