///////////////////////////
// WINDOWS SPECIFIC PART //

#include "stdafx.h"

///////////////////////////

#include "res.h"
#include "datastructs.h"
#include "stuff.h"

bool CMove::Is_Jump () const
{
	if (Number_Of_Positions () > 1)
		for (int i = 1; i < Number_Of_Positions (); i++)
			if ((abs (Get_Position (i).Get_Vertical_Index () - Get_Position (i - 1).Get_Vertical_Index ()) != 2) ||
				(abs (Get_Position (i).Get_Horizontal_Index () - Get_Position (i - 1).Get_Horizontal_Index ()) != 2))
				return false;
	return true;
}

bool CBoard::Create ()
{
	fields = NULL;
	fields = new CFigure** [FIELD_COUNT_VERTICAL];
	if (fields == NULL) return false;
	for (char i = 0; i < FIELD_COUNT_VERTICAL; i++) {
		fields[i] = NULL;
		fields[i] = new CFigure* [FIELD_COUNT_HORIZONTAL];
		if (fields[i] == NULL) return false;
	}
	Init_Fields ();
	return true;
}

void CBoard::Init_Fields ()
{
	for (char i = 0; i < FIELD_COUNT_VERTICAL; i++)
		for (char j = 0; j < FIELD_COUNT_HORIZONTAL; j++)
			fields[i][j] = NULL;
}

CBoard::~CBoard ()
{
	for (char i = 0; i < FIELD_COUNT_VERTICAL; i++) delete fields[i];
	delete fields;
}

CFigure* CBoard::Get_Figure (CPosition& pos) const
{
	return fields[pos.Get_Vertical_Index ()][pos.Get_Horizontal_Index ()];
}

void CBoard::Put_Figure (CPosition& pos, CFigure* fig)
{
	fields[pos.Get_Vertical_Index ()][pos.Get_Horizontal_Index ()] = fig;
}

void CBoard::Remove_Figure (CPosition& pos)
{
	fields[pos.Get_Vertical_Index ()][pos.Get_Horizontal_Index ()] = NULL;
}

const CBoard& CBoard::operator = (const CBoard& board)
{
	if (this != &board)
		for (char i = 0; i < FIELD_COUNT_VERTICAL; i++)
			for (char j = 0; j < FIELD_COUNT_HORIZONTAL; j++)
				fields[i][j] = board.Get_Figure (CPosition (i, j));
	return *this;
}

bool CHistory::Get_Copy(CHistory* hist)
{
	int i = 0;
	for (; i < hist->Number_Of_Items(); i++) delete hist->Get_Value(i);
	hist->Clear();
	CMove* mv = NULL;
	for (i = 0; i < Number_Of_Items(); i++) {
		mv = NULL;
		mv = new CMove;
		if (mv == NULL) return false;
		*mv = *Get_Value(i);
		if (!hist->Insert_Value(mv)) return false;
	}
	return true;
}

void CHistory::DataAsText(char* text)
{
	strcat (text, "History:##Moves:#");
	CMove* move;
	CPosition pos;
	char letter[2]; letter[1] = 0;
	for (int i = 0; i < Number_Of_Items(); i++) {
		move = Get_Value(i);
		if (move->Get_Player() == WHITE) strcat(text, "WHITE: "); else strcat(text, "BLACK: ");
		for (int k = 0; k < move->Number_Of_Positions(); k++) {
			pos = move->Get_Position(k);
			*letter = pos.Get_Vertical_Index() + '0'; strcat(text, letter);
			*letter = pos.Get_Horizontal_Index() + '0'; strcat(text, letter); strcat (text, " ");
		}
		strcat(text, "#");
	}
}

void CBoard::DataAsText(char* text)
{
	strcat (text, "Board:##Positions:#");
	CFigure* fig;
	for (int i = 0; i < FIELD_COUNT_VERTICAL; i++) {
		for (int j = 0; j < FIELD_COUNT_HORIZONTAL; j++) {
			fig = fields[i][j];
			if (fig == NULL) { strcat(text, "XX "); continue; }
			if (fig->Get_Color() == WHITE) strcat(text, "W");
			else if (fig->Get_Color() == BLACK) strcat(text, "B");
			if (fig->Get_Type() == KING) strcat(text, "K ");
			else if (fig->Get_Type() == MAN) strcat(text, "M ");
		}
		strcat (text, "#");
	}
}
