// classes of the game stuff - game board, figures, move, position on board

#ifndef STUFF_INCLUDED_
#define STUFF_INCLUDED_

// class of a position of a figure on the game board

class CPosition {
	char vertical_index;
	char horizontal_index;
public:
	CPosition () { vertical_index = -1; horizontal_index = -1; }
	CPosition (char v, char h) { vertical_index = v; horizontal_index = h; };
	char Get_Vertical_Index () const { return vertical_index; }
	char Get_Horizontal_Index () const { return horizontal_index; }
	void Set_Vertical_Index (char v) { vertical_index = v; }
	void Set_Horizontal_Index (char h) { horizontal_index = h; }
	bool operator == (const CPosition& p) const {
		return ((vertical_index == p.vertical_index) && (horizontal_index == p.horizontal_index));
	}
};

// class of a move

class CMove : public m_CList<CPosition> {
	TColor player;
public:
	bool Is_Last_Position (int i) const { return i == number_items - 1; }
	int Number_Of_Positions () const { return number_items; }
	CPosition Get_Position (int i) const { return Get_Value (i); }
	bool Insert_Position (CPosition p) { return Insert_Value (p); } // inserts new position at the end of the list
	void Remove_Position (int n) { Remove_Item (n); }
	bool Is_Jump () const;
	TColor Get_Player() const { return player; }
	void Set_Player(TColor p) { player = p; }
};

// class of the move history

class CHistory : public m_CList<CMove*> {
public:
	bool Get_Copy(CHistory* hist);
	void DataAsText(char*);
};

// class of the figure

enum TFigure_Type { MAN, KING };

class CFigure {
	TFigure_Type type;
	TColor color;
public:
	CFigure (TFigure_Type t, TColor c) { type = t; color = c; }
	TFigure_Type Get_Type () const { return type; }
	TColor Get_Color () const { return color; }
};

// class of the game board

class CBoard {
	CFigure*** fields;
	void Init_Fields ();
public:
	CBoard () { fields = NULL; }
	~CBoard ();
	bool Create ();
	CFigure* Get_Figure (CPosition&) const;
	void Put_Figure (CPosition&, CFigure*);
	void Remove_Figure (CPosition&);
	const CBoard& operator = (const CBoard&);
	void DataAsText(char*);
};

#endif